; GUI #
include win64a.inc
MUTEX_DATA_COUNT = 16
MUTEX_ALL_ACCESS = 1F0001h
size_of_buffer	 = 96
IDC_DIALOG	equ 200
ID_TXT		equ 100
ID_ICON		equ 102
ID_PROGRESS	equ 106
IDC_ICON1	equ 500
.code
WinMain proc
	enter	30h,0
	mov	r9d,offset DialogProc
	and	qword ptr[rbp-10h],0
        invoke  DialogBoxParam,IMAGE_BASE,IDC_DIALOG,HWND_DESKTOP
        invoke  RtlExitUserProcess,NULL
WinMain endp
DialogProc proc hWnddlg:qword,msg:qword,wParam:qword,lParam:qword


	mov	hWnddlg,rcx
	mov	lParam,r9

        cmp	edx,WM_INITDIALOG
	je 	wmINITDIALOG
	cmp	edx,WM_CLOSE
	je	wmCLOSE
	cmp	edx,WM_COMMAND
	je	wmCOMMAND
	cmp	edx,WM_DESTROY
	je	wmDESTROY
	xor	eax,eax
	jmp	exit0

wmINITDIALOG:mov hWnd,rcx
;   
	mov	edx,offset szWin
        invoke  FindWindow,NULL
        or      eax,eax
        jnz	@f;wmBYE
	mov	edx,offset Error1
	mov	r8d,offset szAppName
	invoke	MessageBox,hWnddlg,,,MB_ICONEXCLAMATION or MB_YESNO
	cmp	eax,IDNO
	jz      @f     
	mov	ecx,offset szService
	invoke	WinExec,,SW_SHOW

@@:	invoke	CreateEvent,NULL, TRUE, FALSE, NULL
	mov	eventStop,rax
	mov	r9d,offset EVENT_BEGIN_TRANSMISSION
	invoke	CreateEventW,NULL, TRUE, FALSE
	mov	eventBegin,rax
	mov	r9d,offset EVENT_END_TRANSMISSION
	invoke	CreateEventW,NULL, TRUE, TRUE
	mov	eventEnd,rax
	mov	r9d,offset EVENT_RECEIVER_READY
	invoke	CreateEventW,NULL, TRUE, FALSE
	mov	eventReceiverReady,rax

	movr	qword ptr[rsp+28h],threadId
	xor	ecx,ecx
	mov	[rsp+20h],rcx
	mov	r8d,offset ReceiverThread
	invoke	CreateThread,,0,,0
	mov	threadHandle,rax
	jmp	wmBYE
wmDESTROY:invoke SetEvent,eventStop
	cmp	threadHandle,0
	jz	@f ; dlg->eventStop
	invoke	WaitForSingleObject,threadHandle,INFINITE
	invoke	CloseHandle,threadHandle

@@:	invoke	CloseHandle,eventStop
	invoke	CloseHandle,eventBegin
	invoke	CloseHandle,eventEnd
	invoke	CloseHandle,eventReceiverReady
	jmp	wmBYE
wmCOMMAND:cmp	r8d,BN_CLICKED shl 16 + IDCANCEL
	jne	wmBYE
wmCLOSE:invoke	EndDialog,,0

wmBYE:	mov	eax,TRUE
exit0:	leave
	retn
DialogProc endp


ReceiverThread proc
local	threadHandle:qword
local	threadId:qword
local	handles[2]:qword
local	index:dword

	mov	rax,eventBegin
	mov	handles[0*8],rax
	mov	rax,eventStop
	mov	handles[1*8],rax

@@:	lea	edx,handles
	invoke	WaitForMultipleObjects,2,,FALSE,INFINITE
	mov	index,eax
	or	eax,eax
	jnz	exit0
        lea	eax,threadId
	mov	[rsp+28h],rax
	xor	ecx,ecx
	mov	[rsp+20h],rcx
	mov	r8d,offset ReceiveMessageThread
	invoke	CreateThread,,0,,0
	mov	threadHandle,rax
	or	eax,eax
	jz	@0;if (threadHandle)
	invoke	WaitForSingleObject,eax, INFINITE
	invoke	CloseHandle,threadHandle
@0:	lea	edx,handles
	invoke	WaitForMultipleObjects,2,,FALSE,INFINITE
	or	eax,eax
	jz	@b
exit0:	leave
	xor	eax,eax
	ret
ReceiverThread endp
ReceiveMessageThread proc
local	handles[18]:qword
local	MutexName[256]:word
local	index:byte
local	value:byte
local	buffer[256]:byte
local	count:dword

	lea	edi,buffer
	xor	eax,eax
	mov	ecx,256/8
	rep	stosq

	xor	edi,edi
@@:	lea	ecx,MutexName
	mov	edx,offset fmt
	invoke	wsprintfW,,,edi
	lea	r8d,MutexName
	invoke	OpenMutexW,MUTEX_ALL_ACCESS,FALSE
	mov	handles[rdi*8],rax
	or	eax,eax
	jz	@3
	inc	edi
	cmp	edi,MUTEX_DATA_COUNT
	jb	@b
    
	mov	rax,eventEnd
	mov	handles[16*8],rax
	mov	rax,eventStop
	mov	handles[17*8],rax

	and	count,0
	and	value,0
	xor	esi,esi

	invoke	SetEvent,eventReceiverReady

@2:	lea	edx,handles
	invoke	WaitForMultipleObjects,18,,FALSE,INFINITE
	mov	index,al
        cmp	al,WAIT_OBJECT_0 + 18
	jb	@f
	sub	index,WAIT_ABANDONED_0
        cmp	index, 17
	ja	break
@@:     cmp	index, 15
	ja	break

	movzx	eax,index
	invoke	ReleaseMutex,handles[rax*8]
	mov	al,value
	shl	al,4
	or	al,index
	mov	value,al;value = (value << 4) | index
	mov	ecx,esi
	inc	esi
	test	ecx,ecx
	jz	@2
	mov	ecx,count
;----------------------------------------------
	mov	edx,-17
	sub	edx,eax
	cmp	edx,1
	jb	@f
	mov	eax,count
	mov	dl,value
	mov	buffer[rax],dl
	inc	count
@@:	and	value,0
	xor	esi,esi
	jmp	@2
;--------------------------------------------------
@3:	or	esi,esi
	jz	exit0;if (!handles[i])
@@:	dec	esi;while (i--)
	invoke	CloseHandle,handles[rsi*8]
	or	esi,esi
	jnz	@b
	jmp	exit0
break:	invoke	ResetEvent,eventReceiverReady

	xor	edi,edi
@@:	invoke	CloseHandle,handles[rdi*8]
	inc	edi
	cmp	edi,MUTEX_DATA_COUNT
	jb	@b
	lea	esi,buffer
	cmp	byte ptr[rsi],0
	jz	exit0
		
	lea	r8d,buffer
        invoke  SetDlgItemText,hWnd,ID_TXT
exit0:	xor	eax,eax
	leave
	ret
ReceiveMessageThread endp
;-----------------------------------------------------------------------
.data
szWin		db "Transmitter",0
Error1		db "The server is not running.",10,"Run?",0
szAppName	db "Mutex Reciever",0
szService	db "09s",0
eventBegin	dq ?
eventEnd	dq ?
eventReceiverReady dq ?
eventStop	dq ?
threadHandle	dq ?
threadId	dd ?
hWnd		dq ?
align 10h
EVENT_BEGIN_TRANSMISSION dw "E","v","B","e","g","i","n","T","r","a","n","s","m","i","s","s","i","o","n",0
EVENT_END_TRANSMISSION   dw "E","v","E","n","d","T","r","a","n","s","m","i","s","s","i","o","n",0
EVENT_RECEIVER_READY     dw "E","v","R","e","c","e","i","v","e","r","R","e","a","d","y",0
fmt			 dw "M","t","x","D","a","t","a",":","%","u",0
end 