; GUI #
include win64a.inc
ID_TXT		equ 100
ID_SEND_TXT	equ 101
IDC_DIALOG	equ 200
IDC_ICON1	equ 500
IDC_IMG1 	equ 104
MUTEX_DATA_COUNT = 16
size_of_buffer	 = 96
MUTEX_ALL_ACCESS equ 1F0001h

.code
WinMain proc 
	enter	30h,0
	mov	r9d,256;cx
	mov	[rbp-10h],r9
	mov	qword ptr [rbp-8],LR_DEFAULTCOLOR
	invoke	LoadImage,IMAGE_BASE,IDC_ICON1,IMAGE_ICON;,256,256,LR_DEFAULTCOLOR
	mov	r9d,offset DialogProc
	mov	qword ptr[rbp-10h],rax;30h-10h=+20h
	invoke	DialogBoxParam,IMAGE_BASE,IDC_DIALOG,HWND_DESKTOP
	invoke	RtlExitUserProcess,NULL
WinMain endp

DialogProc proc hWnddlg:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	MutexName[256]:word
local	SizeString:dword

	mov	hWnddlg,rcx
	mov	lParam,r9

	cmp	edx,WM_INITDIALOG
	je	wmINITDIALOG
	cmp	edx,WM_CLOSE
	je	wmCLOSE
	cmp	edx,WM_COMMAND
	je	wmCOMMAND
	cmp	edx,WM_DESTROY
	je	wmDESTROY
	xor	eax,eax
	jmp	exit0
wmINITDIALOG:mov hWnd,rcx
	invoke	GetDlgItem,,IDC_IMG1
	invoke	SendMessage,eax,STM_SETIMAGE,IMAGE_ICON,lParam
;Create Sync Objects
	xor	edi,edi
@@:	lea	ecx,MutexName
	mov	edx,offset fmt
	invoke	wsprintfW,,,edi
	lea	r8d,MutexName
	invoke	CreateMutexW,0,TRUE
	mov	mutexes[rdi*8],rax
	inc	edi
	cmp	edi,MUTEX_DATA_COUNT
	jb	@b
	mov	r9d,offset EVENT_BEGIN_TRANSMISSION
	invoke	CreateEventW,NULL,TRUE,FALSE
	mov	eventBegin,rax
	mov	r9d,offset EVENT_END_TRANSMISSION
	invoke	CreateEventW,NULL,TRUE,TRUE
	mov	eventEnd,rax
	mov	r9d,offset EVENT_RECEIVER_READY
	invoke	CreateEventW,NULL,TRUE,FALSE
	mov	eventReceiverReady,rax
	jmp	wmBYE
wmSEND_TXT:lea	r8d,MutexName
	invoke	GetDlgItemText,hWnd,ID_TXT,,256
	mov	SizeString,eax
;Send Data--------------------------------------
	invoke	ResetEvent,eventEnd
	invoke	SetEvent,eventBegin
	invoke	WaitForSingleObject,eventReceiverReady,5000
        cmp	eax,WAIT_OBJECT_0
	jnz	@0
        
        lea	esi,MutexName
@@:	movzx	edi,byte ptr[rsi]
	shr	edi,4	
	invoke	ReleaseMutex,mutexes[rdi*8]
	invoke	WaitForSingleObject,mutexes[rdi*8],INFINITE
	movzx	edi,byte ptr[rsi]
	and	edi,0Fh
	invoke	ReleaseMutex,mutexes[rdi*8]
	invoke	WaitForSingleObject,mutexes[rdi*8],INFINITE
        inc	esi
	dec	SizeString
	jnz	@b

@0:	invoke	ResetEvent,eventBegin
	invoke	SetEvent,eventEnd
;-----------------------------------------------
        mov	edx,offset szWin
        invoke  FindWindow,NULL
        invoke	PostMessage,eax,WM_USER+1,hWnddlg
	jmp	wmBYE
wmDESTROY:;Close Sync Objects
	invoke	SetEvent,eventEnd

	invoke	CloseHandle,eventBegin
	invoke	CloseHandle,eventEnd
	invoke	CloseHandle,eventReceiverReady

	xor	edi,edi
@@:	invoke	CloseHandle,mutexes[rdi*8]
	inc	edi
	cmp	edi,MUTEX_DATA_COUNT
	jb	@b
	jmp	wmBYE
; ---------------------------------------------------------------------------
wmCOMMAND:cmp	r8d,BN_CLICKED shl 16 + ID_SEND_TXT
        je      wmSEND_TXT
	cmp     r8d,BN_CLICKED shl 16 + IDCANCEL
        jne     wmBYE
wmCLOSE:invoke	EndDialog,,0
wmBYE:	mov	eax,TRUE
exit0:	leave
	retn
DialogProc endp
;---------------------------------------
.data
szWin		db "Mutex Reciever",0
hWnd		dq ?
align 10h
EVENT_BEGIN_TRANSMISSION dw "E","v","B","e","g","i","n","T","r","a","n","s","m","i","s","s","i","o","n",0
EVENT_END_TRANSMISSION	dw "E","v","E","n","d","T","r","a","n","s","m","i","s","s","i","o","n",0
EVENT_RECEIVER_READY	dw "E","v","R","e","c","e","i","v","e","r","R","e","a","d","y",0
fmt		dw "M","t","x","D","a","t","a",":","%","u",0
mutexes		dq 16 dup(?)
eventBegin	dq ?
eventEnd	dq ?
eventReceiverReady	dq ?
end